define(["libs/text!templates/create.tpl", "libs/text!drawings/derpy.txt", "libs/canvas", "libs/jquery", "libs/underscore"], function(TCreate, DDerpy, Canvas) {
  
  var $node;
  
  function init() {
    $node = $('#content');
    var template=_.template(TCreate);
    $node.empty().append(template({name:$("<div></div>").text(window.user.login).html()}));
    
    var canvas = Canvas.init($node.find('#main-canvas'));
    var canvasderp = Canvas.init($node.find('#secondary-canvas'));
    canvasderp.draw(21, 30, JSON.parse(DDerpy), 1, 3);
    canvasderp.pause(true);
    
    $node.find('#undo').on('click', function() {
      //console.log(JSON.stringify(canvasderp.get()));
      canvas.undo();
      return false;
    });

    $node.find('#clear').on('click', function() {
      canvas.clear();
      //canvasderp.clear();
      return false;
    });
    
    $node.find('#done').on('click', function() {
      var character = canvas.get();
      $('#wrapper').fadeOut(500, function() {
        $node.html('Please wait...');
        $('#wrapper').fadeIn(500, function() {
          $.post('server/character', {data:JSON.stringify(character)}, function(data) {
            window.user.hasCharacter = true;
            require(["mods/game"], function(Game) {
              $('#wrapper').fadeOut(500, function() {
                Game.init();
              });
            });
          }, 'json').error(function() { alert('Error!'); window.location.reload(); });
        });
      });
      return false;
    });

    $node.find('#logout').on('click', function() {
      //console.log(JSON.stringify(canvas.get()));
      $('#wrapper').fadeOut(500, function() {
        $.get('server/logout', {}, function() {
          window.location.reload();
        });
      });
      return false;
    });
    
    $('#wrapper').fadeIn(1000);
  }
  
  return { init: init };
});
